/*
  Project X-One  ˥塼 Sub Routine  menu.c
                    Akito Tajitsu 1998  All Rights Reserved
*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

#ifndef NEXTAW
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Scrollbar.h>
#include <X11/Xaw/Toggle.h>
#else
#include <X11/neXtaw/SimpleMenu.h>
#include <X11/neXtaw/SmeBSB.h>
#include <X11/neXtaw/SmeLine.h>
#include <X11/neXtaw/Label.h>
#include <X11/neXtaw/Command.h>
#include <X11/neXtaw/AsciiText.h>
#include <X11/neXtaw/Box.h>
#include <X11/neXtaw/Form.h>
#include <X11/neXtaw/Scrollbar.h>
#include <X11/neXtaw/Toggle.h>
#endif


#define XPM_WIDTH 165

/* ˥塼ɲ */
void 
menu_add_line(Widget menu)
{
	XtVaCreateManagedWidget("line", smeLineObjectClass, menu, NULL);
}


/* ˥塼˥Хåɲ */
Widget 
menu_add_callback(Widget menu, char *title, XtCallbackProc callback)
{
    Widget entry 
	= XtVaCreateManagedWidget(title, smeBSBObjectClass, menu, NULL);
    XtAddCallback(entry, XtNcallback, callback, NULL);
    return entry;
}

/* ˥塼˥Хåɲ ޥåѹ*/
Widget 
menu_add_callback2(Widget menu, char *title, XtCallbackProc callback,char *mas_str)
{
    Widget entry 
	= XtVaCreateManagedWidget(title, smeBSBObjectClass, menu, NULL);
    XtAddCallback(entry, XtNcallback, callback, mas_str);
    return entry;
}


/* ˥塼˥Хåɲ ޥåѹ*/
Widget 
config_add_widget(Widget menu, Widget fromvert, Widget fromhoriz,
		  WidgetClass wclass, char *title)
{
    Widget entry 
	= XtVaCreateManagedWidget(title, wclass, menu, 
				  XtNfromVert,fromvert,
				  XtNfromHoriz,fromhoriz,
				  NULL);
    return entry;
}

/* ˥塼˥Хåɲ ޥåѹ*/
Widget 
config_add_callback(Widget menu, Widget fromvert, Widget fromhoriz,
		    WidgetClass wclass, char *title,
		    XtCallbackProc callback)
{
    Widget entry 
	= XtVaCreateManagedWidget(title, wclass, menu, 
				  XtNfromVert,fromvert,
				  XtNfromHoriz,fromhoriz,
				  NULL);
    XtAddCallback(entry, XtNcallback, callback, NULL);
    return entry;
}


/* menuΰַ */
void set_menupos(Widget w, Widget ww)
{
    XWindowAttributes att_win,att_root;
    int xpop,ypop;
    Dimension ww_width,ww_height;

  
    XGetWindowAttributes(XtDisplay(w),XtWindow(w),&att_win);
    XGetWindowAttributes(XtDisplay(w),RootWindow(XtDisplay(w),0),&att_root);

    if(XtIsRealized(ww)==False)XtRealizeWidget(ww);

    xpop=att_win.x+XPM_WIDTH;
    ypop=att_win.y;

    XtVaGetValues(ww,
		  XtNwidth,&ww_width,
		  XtNheight,&ww_height,
		  NULL);

    if(xpop+ww_width>att_root.width) 
	xpop=xpop-XPM_WIDTH-ww_width; 
    if(ypop<0) ypop=0;
    else if(ypop+ww_height>att_root.height)
	ypop=att_root.height-ww_height;

    XtVaSetValues(ww,
		  XtNx,xpop,
		  XtNy,ypop,
		  NULL);

}

