/*    for X    from ONE   ء  by Tactics           */
/*  ꥸʥץ  Ϥ뤭Ҥ뤵 WindowsѥץǤ */
/*                http://www.os.xaxon.ne.jp/~haruki/                   */
/*                                                                     */
/*                 Xؤΰܿץ     by A.Tajitsu 1998-9         */ 

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <time.h>
#include <sys/time.h>
#include <math.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xlocale.h>
#include <X11/Xresource.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/xpm.h>
#include <X11/extensions/shape.h>
#include <X11/Shell.h>
#include "akaneclock.h"

#ifndef NEXTAW
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/MenuButton.h>
#else
#include <X11/neXtaw/SimpleMenu.h>
#include <X11/neXtaw/Command.h>
#include <X11/neXtaw/Paned.h>
#include <X11/neXtaw/Form.h>
#include <X11/neXtaw/Toggle.h>
#include <X11/neXtaw/AsciiText.h>
#include <X11/neXtaw/ThreeD.h>
#include <X11/neXtaw/MenuButton.h>
#endif

#include "bitmap/yubi.xbm"
#include "bitmap/yubi_mask.xbm"
#include "bitmap/osu.xbm"
#include "bitmap/osu_mask.xbm"
#include "bitmap/tumamu.xbm"
#include "bitmap/tumamu_mask.xbm"

#include "pixmap/akane_clock2.xpm"
#include "pixmap/p_second.xpm"
#include "pixmap/p_minute.xpm"
#include "pixmap/p_hour.xpm"




Cursor set_cursor();      /* ޥ */
void EnterCursor();
void LeaveCursor();
void HotkeyConfig();
void HotkeyQuit();
void Press();
void ReleaseMascot();
void MotionMascot();
void DecayBalloon();
void make_hands();
void update_second();
void make_menu();
void make_config();
void timing_adjust();
void static ExitDialog();
void static ConfigPopup();
void static ConfigPopdown();
void static ConfigCancel();
void static SigCheck();
void SetChangeHand();
void ChangeHand();
void ext_play();
void ChildTerm();
void sound_play();
void GetResource();
void SaveResource();
void BalloonModeChange();

void InitBalloon();
void DoBalloon();
void ShapeBalloon();   /* դWindowȴ */
void drawBalloon();    /* դ */
int SetBalloonPos();       /* դΰַ */

Pixel GetColor();         /* б Pixel  */
XChar2b	*Str2bCpy( );     /* 2byteʸؤΥԡ */

static Pixmap *pix_mascot,*msk_mascot,
    pix_second,msk_second,
    pix_minute,msk_minute,
    pix_hour,msk_hour;
static GC gc, gc_balloon;
Cursor cursor_normal,cursor_osu,cursor_tumamu;
XtAppContext app;
Widget hour,minute,second,popup,mascot,conf_top;
static int xpop,ypop;
static int      motion_fl;      /* ɥå?   */
char sound_command[128],sound_file[128],ext_command[128];
Status signal_fl=0;
Widget conf_sig_stat,conf_sig_wavcmd,conf_sig_wav,conf_sig_cmd;
Widget conf_bal_fg,conf_bal_bg,conf_bal_border,conf_bal_font;
Widget conf_bal_m1,conf_bal_p1,conf_bal_m2,conf_bal_p2;
Widget conf_baloff_x,conf_baloff_y,conf_balmenu;
XtIntervalId signal_id,balloon_decay_id;
Boolean balloon_decay_fl=False;
Window balloon;
Pixel fg_balloon=0,bg_balloon=0,border_balloon=0; /* Х롼ο */
char BalloonFont[1024];
char BalloonFG[256],BalloonBG[256],BalloonBorder[256];
int BalloonBorderWidth=1,BalloonMode,BalloonMode_backup;
int BalloonOffX, BalloonOffY;
XFontStruct *theFont;
Boolean  useSaveUnder=True;
int BalloonPosition;

int pre_min=-1;


/* ץ١Υǥեȥ */
String          trans =
"<Enter>: enter_cursor()\n"
"<Leave>: leave_cursor()\n"
"Ctrl<Btn1Down>: hotkey_config()\n"
"Ctrl<Btn3Down>: hotkey_quit()\n"
"<Btn1Down>: press()\n"
"<Btn1Up>: release_mascot()\n"
"<Btn1Motion>: motion_mascot()\n"
"<Btn3Down>: XawPositionSimpleMenu(popup) XtMenuPopup(popup)";

static XtActionsRec actions[] = {
    {"enter_cursor", EnterCursor},
    {"leave_cursor", LeaveCursor},
    {"hotkey_config", HotkeyConfig},
    {"hotkey_quit", HotkeyQuit},
    {"press", Press},
    {"release_mascot", ReleaseMascot},
    {"motion_mascot", MotionMascot},
};


int main(argc, argv)
     int argc;
     char **argv;
{
    Display *d;
    XSetWindowAttributes att;
    int i_pat;
    unsigned int root_width,root_height;
    XWindowAttributes att_win;
    XEvent event;
    XpmAttributes att_xpm;
    

    signal(SIGCHLD,ChildTerm);

#ifdef I18N    
    XtSetLanguageProc(NULL,NULL,NULL);
#endif

    pix_mascot = (Pixmap *) malloc(NUM_MASCOT * sizeof(Pixmap));
    msk_mascot = (Pixmap *) malloc(NUM_MASCOT * sizeof(Pixmap));

	
    mascot = XtVaAppInitialize(&app,"Akaneclock",NULL,0,&argc,argv,NULL,NULL);
    d = XtDisplay(mascot);
    XtSetMappedWhenManaged(mascot,False);
    

    XawSimpleMenuAddGlobalActions(app);
    XtAppAddActions(app, actions, XtNumber(actions));
    XtOverrideTranslations(mascot, XtParseTranslationTable(trans));

    cursor_normal = set_cursor(d,(char*)yubi_bits,(char*)yubi_mask_bits,
                               yubi_width,yubi_height,yubi_x_hot,yubi_y_hot);
    cursor_osu = set_cursor(d,(char*)osu_bits,(char*)osu_mask_bits,
                               osu_width,osu_height,osu_x_hot,osu_y_hot);
    cursor_tumamu = set_cursor(d,(char*)tumamu_bits,(char*)tumamu_mask_bits,
                               tumamu_width,tumamu_height,tumamu_x_hot,
			       tumamu_y_hot);

    /* Root Window */
    root_width = WidthOfScreen(XtScreen(mascot));
    root_height  = HeightOfScreen(XtScreen(mascot));
    
    XtVaSetValues(mascot,
		  XtNwidth,XPM_WIDTH,
		  XtNheight,XPM_HEIGHT,
		  NULL);

    XtRealizeWidget(mascot); /* Widget  Realize */
    gc = XCreateGC(d,XtWindow(mascot),0,0);

    XDefineCursor(d,XtWindow(mascot),cursor_normal);

    att.override_redirect = True;
    XChangeWindowAttributes(d,XtWindow(mascot),
			    CWOverrideRedirect,&att);
    att.backing_store = Always;
    XChangeWindowAttributes(d,XtWindow(mascot),
			    CWBackingStore,&att);


    att_xpm.valuemask = XpmCloseness|XpmReturnPixels;
    att_xpm.closeness = 20000;
    XpmCreatePixmapFromData(d,XtWindow(mascot),akane_clock2,
			    &pix_mascot[0],&msk_mascot[0],&att_xpm);

    XSetWindowBackgroundPixmap(d,XtWindow(mascot),pix_mascot[0]);
    XShapeCombineMask(d,XtWindow(mascot),
		      ShapeBounding,0,0,(Pixmap)msk_mascot[0],ShapeSet);


    GetResource(d,mascot);

    XMapWindow(d,XtWindow(mascot));
    XFlush(d);

    XGetWindowAttributes(d,XtWindow(mascot),&att_win);

    xpop=att_win.x;
    ypop=att_win.y;

    make_menu(d,mascot);
    make_hands(d, mascot);
    make_config(d,mascot);

    if(signal_fl){
	SetChangeHand();
    }

    InitBalloon(d);
    DoBalloon(d,True);

    timing_adjust();
    while (1) {
	if (XtAppPending(app)){
	    XtAppProcessEvent(app, XtIMAll);
	}
	else{
	    update_second();
	    DoBalloon(d,False);
	    usleep(SLEEP);
	}
    }
}


/*  */
Cursor set_cursor(d, pat, mask, w, h, x, y)
    Display *d;
    char *pat, *mask;
    unsigned w, h;
    int x, y;
{
        Pixmap cur_pat,cur_mask;
        Cursor ret;
        XColor black,white;

        black.red = black.green = black.blue = 0;
        white.red = white.green = white.blue = 0xffff;

        cur_pat  = XCreateBitmapFromData(d,RootWindow(d,0),pat,w,h);
        cur_mask = XCreateBitmapFromData(d,RootWindow(d,0),mask,w,h);
        ret = XCreatePixmapCursor(d,cur_pat,cur_mask,&black,&white,x,y);

        XFreePixmap(d,cur_pat);
        XFreePixmap(d,cur_mask);
        return ret;
}


/* ÿ,Ĺ,ûˤ */
void make_hands(Display *d, Widget w)
{
    XpmAttributes att_xpm;

    second = XtCreateWidget("second",
			    overrideShellWidgetClass, w, NULL, 0);
    XtSetMappedWhenManaged(second, False);
    XtVaSetValues(second, 
		  XtNwidth, (Dimension)SEC_SIZE,
		  XtNheight,(Dimension)SEC_SIZE,
		  XtNborderWidth, (Dimension)0, NULL);
    XtRealizeWidget(second);

    att_xpm.valuemask = XpmCloseness|XpmReturnPixels;
    att_xpm.closeness = 20000;
    XpmCreatePixmapFromData(d,XtWindow(second),p_second,
			    &pix_second,&msk_second,&att_xpm);

    XSetWindowBackgroundPixmap(d,XtWindow(second),pix_second);
    XShapeCombineMask(d,XtWindow(second),
		      ShapeBounding,0,0,(Pixmap)msk_second,ShapeSet);

    minute = XtCreateWidget("minute",
			    overrideShellWidgetClass, w, NULL, 0);
    XtSetMappedWhenManaged(minute, False);
    XtVaSetValues(minute, 
		  XtNwidth, (Dimension)MIN_SIZE,
		  XtNheight,(Dimension)MIN_SIZE,
		  XtNborderWidth, (Dimension)0, NULL);
    XtRealizeWidget(minute);

    XpmCreatePixmapFromData(d,XtWindow(minute),p_minute,
			    &pix_minute,&msk_minute,&att_xpm);

    XSetWindowBackgroundPixmap(d,XtWindow(minute),pix_minute);
    XShapeCombineMask(d,XtWindow(minute),
		      ShapeBounding,0,0,(Pixmap)msk_minute,ShapeSet);

    hour = XtCreateWidget("hour",
			    overrideShellWidgetClass, w, NULL, 0);
    XtSetMappedWhenManaged(hour, False);
    XtVaSetValues(hour, 
		  XtNwidth, (Dimension)HUR_SIZE,
		  XtNheight,(Dimension)HUR_SIZE,
		  XtNborderWidth, (Dimension)0, NULL);
    XtRealizeWidget(hour);

    XpmCreatePixmapFromData(d,XtWindow(hour),p_hour,
			    &pix_hour,&msk_hour,&att_xpm);

    XSetWindowBackgroundPixmap(d,XtWindow(hour),pix_hour);
    XShapeCombineMask(d,XtWindow(hour),
		      ShapeBounding,0,0,(Pixmap)msk_hour,ShapeSet);

    update_second();


    XMapWindow(d,XtWindow(second));
    XMapWindow(d,XtWindow(minute));
    XMapWindow(d,XtWindow(hour));
    XFlush(d);
}

/* פĴ */
void timing_adjust()
{
    struct timeval t;
    long priset;

    gettimeofday(&t,NULL);
    priset = t.tv_usec-(t.tv_usec/(SLEEP))*(SLEEP)-100;
    if (priset<100){
	priset=0;
    }

    usleep(t.tv_usec-(t.tv_usec/(SLEEP))*(SLEEP));
}

/* פοˤοʹ */
void update_second()
{
    time_t t;
    struct tm *tmpt;

    t = time(NULL);
    tmpt = localtime(&t);

    XtMoveWidget
	(second,
	 xpop+XPM_OFFSET+(int)(R_SEC*sin(PI/180*6*(double)(tmpt->tm_sec)))
	  -SEC_OFFSET,
	 ypop+XPM_OFFSET-(int)(R_SEC*cos(PI/180*6*(double)(tmpt->tm_sec)))
	  -SEC_OFFSET);

    XtMoveWidget
	(minute,
	 xpop+XPM_OFFSET+(int)(R_MIN*sin(PI/180*6*(double)(tmpt->tm_min)))
	  -MIN_OFFSET,
	 ypop+XPM_OFFSET-(int)(R_MIN*cos(PI/180*6*(double)(tmpt->tm_min)))
          -MIN_OFFSET);

    XtMoveWidget
	(hour,
	 xpop+XPM_OFFSET+(int)(R_HUR*sin(PI/180*(30*(double)(tmpt->tm_hour)+
				 (double)(tmpt->tm_min)/2)))-HUR_OFFSET,
	 ypop+XPM_OFFSET-(int)(R_HUR*cos(PI/180*(30*(double)(tmpt->tm_hour)+
				 (double)(tmpt->tm_min)/2)))-HUR_OFFSET);
}
    

/* Popup Menu ι */
void make_menu(Display *d, Widget w)
{
    int mascot_no;
    static char mascot_str[NUM_MASCOT][5];
    
    popup = XtVaCreatePopupShell("popup",
				 simpleMenuWidgetClass,
				 w,
				 NULL);
    

#ifndef I18N
    menu_add_callback(popup,"Signal Config",ConfigPopup);
#else
    menu_add_callback(popup,"",ConfigPopup);
#endif

#ifndef I18N
    menu_add_callback(popup,"Quit",ExitDialog);
#else
    menu_add_callback(popup,"λ",ExitDialog);
#endif
}

/* Config Menu ι */
void make_config(Display *d, Widget w)
{
    Widget conf_box,conf_ok,conf_ccl,conf_ver, conf_bal_l;
    Widget conf_sig_lwav,conf_sig_lwavcmd,conf_sig_lcmd;
    Widget conf_bal_lfg,conf_bal_lbg,conf_bal_lborder,conf_bal_lfont;
    Widget conf_balpos_l,conf_baloff_l,conf_baloff_lx,conf_baloff_ly;
    Widget conf_balmenu_l,balmenu_popup;
    char tmp[50];

    conf_top = 
	XtVaCreatePopupShell("Akane Clock  Configuration",
			     transientShellWidgetClass,
			     w,
			     NULL);


    conf_box=XtVaCreateManagedWidget("general_box",
				       formWidgetClass,
				       conf_top,
				       XtNborderWidth,0,
				       NULL);


    conf_sig_stat=XtVaCreateManagedWidget(
#ifndef I18N
					  "Use Time Signal",
#else
					  "Ĥ餹",
#endif
					  toggleWidgetClass,
					  conf_box,
#ifdef NEXTAW
					  XtNtoggleStyle,XtToggleCheck,
#endif
					  XtNvertDistance,(Dimension)10,
					  NULL);
    XtAddCallback(conf_sig_stat,XtNcallback,SigCheck,NULL);

   
#ifndef I18N
    strcpy(tmp,"Akane Clock : Version");
#else
    strcpy(tmp," : Version");
#endif
    strcat(tmp,VERSION);

    conf_ver=XtVaCreateManagedWidget(tmp,
				     labelWidgetClass,
				     conf_box,
				     XtNfromHoriz,conf_sig_stat,
				     XtNborderWidth,(Dimension)0,
				     XtNhorizDistance,(Dimension)30,
#ifdef NEXTAW
				     XtNshadowWidth,0,
#endif
				     NULL);


    conf_sig_lwav=XtVaCreateManagedWidget(
#ifndef I18N
					  "Sound File",
#else
					  "ɥե",
#endif
					  labelWidgetClass,
					  conf_box,
					  XtNfromVert,conf_sig_stat,
					  XtNborderWidth,(Dimension)0,
#ifdef NEXTAW
					  XtNshadowWidth,0,
#endif
					  NULL);

    conf_sig_lwavcmd=XtVaCreateManagedWidget(
#ifndef I18N
					     "Sound Command",
#else
					     "ɺޥ",
#endif
					     labelWidgetClass,
					     conf_box,
					     XtNfromVert,conf_sig_lwav,
					     XtNborderWidth,(Dimension)0,
#ifdef NEXTAW
					     XtNshadowWidth,0,
#endif
					     NULL);

    conf_sig_lcmd=XtVaCreateManagedWidget(
#ifndef I18N
					  "Ext. Command",
#else
					  "ޥ",
#endif
					  labelWidgetClass,
					  conf_box,
					  XtNfromVert,conf_sig_lwavcmd,
					  XtNborderWidth,(Dimension)0,
					  XtNvertDistance,(Dimension)10,
#ifdef NEXTAW
					  XtNshadowWidth,0,
#endif
					  NULL);
					  

    conf_sig_wav=XtVaCreateManagedWidget("sig_wav",
					 asciiTextWidgetClass,
					 conf_box,
					 XtNeditType,XawtextEdit,
					 XtNtype,XawAsciiString,
					 XtNwidth,(Dimension)240,
					 XtNfromVert,conf_sig_stat,
					 XtNfromHoriz,conf_sig_lwavcmd,
					 NULL);

    conf_sig_wavcmd=XtVaCreateManagedWidget("sig_wavcmd",
					    asciiTextWidgetClass,
					    conf_box,
					    XtNeditType,XawtextEdit,
					    XtNtype,XawAsciiString,
					    XtNwidth,(Dimension)240,
					    XtNfromVert,conf_sig_lwav,
					    XtNfromHoriz,conf_sig_lwavcmd,
					    NULL);

    conf_sig_cmd=XtVaCreateManagedWidget("sig_cmd",
					 asciiTextWidgetClass,
					 conf_box,
					 XtNeditType,XawtextEdit,
					 XtNtype,XawAsciiString,
					 XtNwidth,(Dimension)240,
					 XtNfromVert,conf_sig_lwavcmd,
					 XtNfromHoriz,conf_sig_lwavcmd,
					 XtNvertDistance,(Dimension)10,
					 NULL);
			 
					  
    conf_bal_l=XtVaCreateManagedWidget(
#ifndef I18N
				       "Balloon Conf.",
#else
				       "դ",
#endif
				       labelWidgetClass,
				       conf_box,
				       XtNfromVert,conf_sig_lcmd,
				       XtNborderWidth,(Dimension)0,
				       XtNvertDistance,(Dimension)10,
#ifdef NEXTAW
				       XtNshadowWidth,0,
#endif
				       NULL);
		  
    conf_bal_lfg=XtVaCreateManagedWidget(
#ifndef I18N
					 "Foreground",
#else
					 "Foreground",
#endif
					 labelWidgetClass,
					 conf_box,
					 XtNfromVert,conf_sig_lcmd,
					 XtNfromHoriz,conf_bal_l,
					 XtNborderWidth,(Dimension)0,
					 XtNvertDistance,(Dimension)10,
					 XtNhorizDistance,(Dimension)8,
#ifdef NEXTAW
				       XtNshadowWidth,0,
#endif
				       NULL);

    conf_bal_lbg=XtVaCreateManagedWidget(
#ifndef I18N
					 "Background",
#else
					 "Background",
#endif
					 labelWidgetClass,
					 conf_box,
					 XtNfromVert,conf_bal_lfg,
					 XtNfromHoriz,conf_bal_l,
					 XtNborderWidth,(Dimension)0,
					 XtNhorizDistance,(Dimension)8,
#ifdef NEXTAW
					 XtNshadowWidth,0,
#endif
					 NULL);

    conf_bal_lborder=XtVaCreateManagedWidget(
#ifndef I18N
					 "Border",
#else
					 "Border",
#endif
					 labelWidgetClass,
					 conf_box,
					 XtNfromVert,conf_bal_lbg,
					 XtNfromHoriz,conf_bal_l,
					 XtNborderWidth,(Dimension)0,
					 XtNhorizDistance,(Dimension)8,
#ifdef NEXTAW
					 XtNshadowWidth,0,
#endif
					 NULL);

    conf_bal_lfont=XtVaCreateManagedWidget(
#ifndef I18N
					   "Font",
#else
					   "Font",
#endif
					   labelWidgetClass,
					   conf_box,
					   XtNfromVert,conf_bal_lborder,
					   XtNfromHoriz,conf_bal_l,
					   XtNborderWidth,(Dimension)0,
					   XtNhorizDistance,(Dimension)8,
#ifdef NEXTAW
					 XtNshadowWidth,0,
#endif
					 NULL);

    conf_bal_fg=XtVaCreateManagedWidget("bal_fg",
					asciiTextWidgetClass,
					conf_box,
					XtNeditType,XawtextEdit,
					XtNtype,XawAsciiString,
					XtNwidth,(Dimension)140,
					XtNfromVert,conf_sig_lcmd,
					XtNfromHoriz,conf_bal_lfg,
					XtNvertDistance,(Dimension)8,
					NULL);


    conf_bal_bg=XtVaCreateManagedWidget("bal_bg",
					asciiTextWidgetClass,
					conf_box,
					XtNeditType,XawtextEdit,
					XtNtype,XawAsciiString,
					XtNwidth,(Dimension)140,
					XtNfromVert,conf_bal_fg,
					XtNfromHoriz,conf_bal_lfg,
					NULL);

    conf_bal_border=XtVaCreateManagedWidget("bal_border",
					    asciiTextWidgetClass,
					    conf_box,
					    XtNeditType,XawtextEdit,
					    XtNtype,XawAsciiString,
					    XtNwidth,(Dimension)140,
					    XtNfromVert,conf_bal_bg,
					    XtNfromHoriz,conf_bal_lfg,
					    NULL);


    conf_bal_font=XtVaCreateManagedWidget("bal_font",
					  asciiTextWidgetClass,
					  conf_box,
					  XtNeditType,XawtextEdit,
					  XtNtype,XawAsciiString,
					  XtNwidth,(Dimension)240,
					  XtNfromVert,conf_bal_border,
					  XtNfromHoriz,conf_bal_lfont,
					  NULL);


    conf_balpos_l=XtVaCreateManagedWidget(
#ifndef I18N
					  "Balloon Pos.",
#else
					  "դ",
#endif
					  labelWidgetClass,
					  conf_box,
					  XtNfromVert,conf_bal_font,
					  XtNborderWidth,(Dimension)0,
					  XtNvertDistance,(Dimension)10,
#ifdef NEXTAW
					  XtNshadowWidth,0,
#endif
					  NULL);


    conf_bal_m1=XtVaCreateManagedWidget(
#ifndef I18N
					"LeftTop",
#else
					"",
#endif
					toggleWidgetClass,
					conf_box,
					XtNfromVert,conf_bal_font,
					XtNfromHoriz,conf_balpos_l,
#ifdef NEXTAW
					XtNtoggleStyle,XtToggleCheck,
#endif
					NULL);

    conf_bal_p1=XtVaCreateManagedWidget(
#ifndef I18N
					"RightTop",
#else
					"",
#endif
					toggleWidgetClass,
					conf_box,
					XtNfromVert,conf_bal_font,
					XtNfromHoriz,conf_bal_m1,
#ifdef NEXTAW
					XtNtoggleStyle,XtToggleCheck,
#endif
					XtNradioGroup,conf_bal_m1,
					NULL);
		  
    conf_bal_m2=XtVaCreateManagedWidget(
#ifndef I18N
					"LeftBottom",
#else
					"",
#endif
					toggleWidgetClass,
					conf_box,
					XtNfromVert,conf_bal_m1,
					XtNfromHoriz,conf_balpos_l,
#ifdef NEXTAW
					XtNtoggleStyle,XtToggleCheck,
#endif
					XtNradioGroup,conf_bal_m1,
					NULL);

    conf_bal_p2=XtVaCreateManagedWidget(
#ifndef I18N
					"RightBottom",
#else
					"",
#endif
					toggleWidgetClass,
					conf_box,
					XtNfromVert,conf_bal_m1,
					XtNfromHoriz,conf_bal_m1,
#ifdef NEXTAW
					XtNtoggleStyle,XtToggleCheck,
#endif
					XtNradioGroup,conf_bal_m1,
					NULL);

    conf_baloff_l=XtVaCreateManagedWidget(
#ifndef I18N
					  "Balloon Offset",
#else
					  "դOffset",
#endif
					  labelWidgetClass,
					  conf_box,
					  XtNfromVert,conf_bal_font,
					  XtNfromHoriz,conf_bal_p2,
					  XtNborderWidth,(Dimension)0,
					  XtNvertDistance,(Dimension)10,
					  XtNhorizDistance,(Dimension)10,
#ifdef NEXTAW
					  XtNshadowWidth,0,
#endif
					  NULL);

    conf_baloff_lx=XtVaCreateManagedWidget("X",
					   labelWidgetClass,
					   conf_box,
					   XtNfromVert,conf_baloff_l,
					   XtNfromHoriz,conf_bal_p2,
					   XtNborderWidth,(Dimension)0,
					   XtNhorizDistance,(Dimension)10,
#ifdef NEXTAW
					   XtNshadowWidth,0,
#endif
					   NULL);

    conf_baloff_x=XtVaCreateManagedWidget("bal_off_x",
					  asciiTextWidgetClass,
					  conf_box,
					  XtNeditType,XawtextEdit,
					  XtNtype,XawAsciiString,
					  XtNwidth,(Dimension)30,
					  XtNfromVert,conf_baloff_l,
					  XtNfromHoriz,conf_baloff_lx,
					  NULL);

    conf_baloff_ly=XtVaCreateManagedWidget("Y",
					   labelWidgetClass,
					   conf_box,
					   XtNfromVert,conf_baloff_l,
					   XtNfromHoriz,conf_baloff_x,
					   XtNborderWidth,(Dimension)0,
					   XtNhorizDistance,(Dimension)5,
#ifdef NEXTAW
					   XtNshadowWidth,0,
#endif
					   NULL);

    conf_baloff_y=XtVaCreateManagedWidget("bal_off_y",
					  asciiTextWidgetClass,
					  conf_box,
					  XtNeditType,XawtextEdit,
					  XtNtype,XawAsciiString,
					  XtNwidth,(Dimension)30,
					  XtNfromVert,conf_baloff_l,
					  XtNfromHoriz,conf_baloff_ly,
					  NULL);


    conf_balmenu_l=XtVaCreateManagedWidget(
#ifndef I18N
					  "Balloon Mode",
#else
					  "դMode",
#endif
					  labelWidgetClass,
					  conf_box,
					  XtNfromVert,conf_baloff_y,
					  XtNborderWidth,(Dimension)0,
#ifdef NEXTAW
					  XtNshadowWidth,0,
#endif
					  NULL);

    conf_balmenu=XtVaCreateManagedWidget("BalloonMode",
					 menuButtonWidgetClass,
					 conf_box,
					 XtNmenuName,"balmenu_popup",
					 XtNjustify,XtJustifyLeft,
					 XtNfromVert,conf_baloff_y,
					 XtNfromHoriz,conf_balmenu_l,
					 XtNwidth,(Dimension)200,
#ifdef NEXTAW
					 XtNmenuButtonStyle,
					 XtMenuButtonSelect,
#endif
					 NULL);

    balmenu_popup=XtVaCreatePopupShell("balmenu_popup",
				       simpleMenuWidgetClass,
				       conf_balmenu,
				       NULL);

    menu_add_callback2(balmenu_popup,
#ifndef I18N
		       "Always no Balloon",
#else
		       "ɽʤ",
#endif
		       BalloonModeChange,"0");

    menu_add_callback2(balmenu_popup,
#ifndef I18N
		       "Always Balloon",
#else
		       "ɽ",
#endif
		       BalloonModeChange,"1");

    menu_add_callback2(balmenu_popup,
#ifndef I18N
		       "When Button1 pressed",
#else
		       "ޥåɽ(10)",
#endif
		       BalloonModeChange,"2");

    menu_add_callback2(balmenu_popup,
#ifndef I18N
		       "When Cursor entered",
#else
		       "ɽ",
#endif
		       BalloonModeChange,"3");
		  
    conf_ok=XtVaCreateManagedWidget("OK",
				    commandWidgetClass,
				    conf_box,
				    XtNfromVert,conf_balmenu,
				    XtNvertDistance,(Dimension)10,
				    NULL);
    XtAddCallback(conf_ok,XtNcallback,ConfigPopdown,NULL);
    
    conf_ccl=XtVaCreateManagedWidget(
#ifndef I18N
				     "Cancel",
#else
				     "󥻥",
#endif
				     commandWidgetClass,
				     conf_box,
				     XtNfromHoriz,conf_ok,
				     XtNfromVert,conf_balmenu,
				     XtNvertDistance,(Dimension)10,
				     NULL);
    XtAddCallback(conf_ccl,XtNcallback,ConfigCancel,NULL);

}

void
BalloonModeChange(Widget w, char * act_str, caddr_t call_data)
    /* General Config Window Ǥλ󥢥ѹ */
{
  if(balloon_decay_fl){
    XtRemoveTimeOut(balloon_decay_id);
  }

  if(!strcmp(act_str,"0")){
    XtVaSetValues(conf_balmenu,XtNlabel,
#ifndef I18N
		  "Always no Balloon",
#else
		  "ɽʤ",
#endif
		  XtNwidth,(Dimension)200,NULL);
    BalloonMode=0;
  }
  else if(!strcmp(act_str,"1")){
    XtVaSetValues(conf_balmenu,XtNlabel,
#ifndef I18N
		  "Always Balloon",
#else
		  "ɽ",
#endif
		  XtNwidth,(Dimension)200,NULL);
    BalloonMode=1;
  }
  else if(!strcmp(act_str,"2")){
    XtVaSetValues(conf_balmenu,XtNlabel,
#ifndef I18N
		  "When Button1 pressed",
#else
		  "ޥåɽ(10)",
#endif
		  XtNwidth,(Dimension)200,NULL);
    BalloonMode=2;
  }
  else{
    XtVaSetValues(conf_balmenu,XtNlabel,
#ifndef I18N
		  "When Cursor entered",
#else
		  "ɽ",
#endif
		  XtNwidth,(Dimension)200,NULL);
    BalloonMode=3;
  }
}


/* λ */
void static
ExitDialog(Widget w, XtPointer dat, XtPointer call)
{
  SaveResource(mascot);
  exit(0);
}


static void ConfigPopup(w,client_data,call_data)
     /* Config Window Popup Callback */
     Widget w;
     caddr_t client_data;
     caddr_t call_data;
{
  char tmp[5];

    XtVaSetValues(conf_sig_stat,XtNstate,signal_fl,NULL);
    
    XtVaSetValues(conf_sig_wav,XtNstring,XtNewString(sound_file),NULL);
    XtVaSetValues(conf_sig_wavcmd,XtNstring,XtNewString(sound_command),NULL);
    XtVaSetValues(conf_sig_cmd,XtNstring,XtNewString(ext_command),NULL);

    XtVaSetValues(conf_bal_fg,XtNstring,XtNewString(BalloonFG),NULL);
    XtVaSetValues(conf_bal_bg,XtNstring,XtNewString(BalloonBG),NULL);
    XtVaSetValues(conf_bal_border,XtNstring,XtNewString(BalloonBorder),NULL);
    XtVaSetValues(conf_bal_font,XtNstring,XtNewString(BalloonFont),NULL);

    if(BalloonPosition==-1){
      XtVaSetValues(conf_bal_m1,XtNstate,True,NULL);
    }
    else if(BalloonPosition==1){
      XtVaSetValues(conf_bal_p1,XtNstate,True,NULL);
    }
    else if(BalloonPosition==-2){
      XtVaSetValues(conf_bal_m2,XtNstate,True,NULL);
    }
    else{
      XtVaSetValues(conf_bal_p2,XtNstate,True,NULL);
    }

    sprintf(tmp,"%d",BalloonOffX);
    XtVaSetValues(conf_baloff_x,XtNstring,XtNewString(tmp),NULL);
    sprintf(tmp,"%d",BalloonOffY);
    XtVaSetValues(conf_baloff_y,XtNstring,XtNewString(tmp),NULL);

    BalloonMode_backup=BalloonMode;
    sprintf(tmp,"%d",BalloonMode);
    BalloonModeChange(NULL, tmp, NULL);

    SigCheck(conf_sig_stat,NULL,NULL);

    set_menupos(mascot,conf_top);
    
    XtPopup(conf_top,XtGrabExclusive);
}
  


static void ConfigPopdown(w,client_data,call_data)
     /* Config Window  ѹcancel & popdown */
     Widget w;
     caddr_t client_data;
     caddr_t call_data;
{
    Boolean sw,sw2;
    String str;

    XtVaGetValues(conf_sig_stat,XtNstate,&sw,NULL);

    if(sw==True){
	XtVaGetValues(conf_sig_wav,XtNstring,&str,NULL);
	strcpy(sound_file,str);

	XtVaGetValues(conf_sig_wavcmd,XtNstring,&str,NULL);
	strcpy(sound_command,str);

	XtVaGetValues(conf_sig_cmd,XtNstring,&str,NULL);
	strcpy(ext_command,str);

    }

    XtVaGetValues(conf_bal_fg,XtNstring,&str,NULL);
    strcpy(BalloonFG,str);
    XtVaGetValues(conf_bal_bg,XtNstring,&str,NULL);
    strcpy(BalloonBG,str);
    XtVaGetValues(conf_bal_border,XtNstring,&str,NULL);
    strcpy(BalloonBorder,str);
    XtVaGetValues(conf_bal_font,XtNstring,&str,NULL);
    strcpy(BalloonFont,str);

    XtVaGetValues(conf_bal_m1,XtNstate,&sw2,NULL);
    if(sw2){
      BalloonPosition=-1;
    }
    else{
      XtVaGetValues(conf_bal_p1,XtNstate,&sw2,NULL);
      if(sw2){
	BalloonPosition=1;
      }
      else{
	XtVaGetValues(conf_bal_m2,XtNstate,&sw2,NULL);
	if(sw2){
	  BalloonPosition=-2;
	}
	else{
	  BalloonPosition=2;
	}
      }
    }

    XtVaGetValues(conf_baloff_x,XtNstring,&str,NULL);
    BalloonOffX=atoi(str);
    XtVaGetValues(conf_baloff_y,XtNstring,&str,NULL);
    BalloonOffY=atoi(str);

    XDestroyWindow(XtDisplay(w),balloon);
    InitBalloon(XtDisplay(w));
    DoBalloon(XtDisplay(w),True);


    if(signal_fl==True){
	XtRemoveTimeOut(signal_id);
    }
    if(sw==True){
	SetChangeHand();
    }

    signal_fl=sw;

    SaveResource(mascot);

    XtPopdown(conf_top);
    XFlush(XtDisplay(w));
}

static void ConfigCancel(w,client_data,call_data)
     /* Config Window  ѹcancel & popdown */
     Widget w;
     caddr_t client_data;
     caddr_t call_data;
{
  BalloonMode=BalloonMode_backup;

  XtPopdown(conf_top);
  XFlush(XtDisplay(w));
}



/* Hotkey (F1) ˤꥦɥεư */
void
HotkeyConfig(Widget w, XEvent * e, String * p, Cardinal * n)
{
    ConfigPopup(w,NULL,NULL);
}

/* Hotkey (Shift+F12) ˤ뽪λ */
void
HotkeyQuit(Widget w, XEvent * e, String * p, Cardinal * n)
{
    SaveResource(mascot);
    exit(0);
}

/* 뤬ä */
void
EnterCursor(Widget w, XEvent * e, String * p, Cardinal * n)
{
  if((BalloonMode==3)){
    XMapWindow(XtDisplay(w),balloon);
  }
}

/* 뤬Ф */
void
LeaveCursor(Widget w, XEvent * e, String * p, Cardinal * n)
{
  if((BalloonMode==3)){
    XUnmapWindow(XtDisplay(w),balloon);
  }
}

/* ܥ򲡤 */
void
Press(Widget w, XEvent * e, String * p, Cardinal * n)
{
        Window          root, child;
        int             rx, ry;
        u_int           key;

        motion_fl = 0;

        XDefineCursor(XtDisplay(w), XtWindow(w), cursor_osu);
	/*XRaiseWindow(XtDisplay(w),XtWindow(w));*/
}

/* ץ١   ܥΥ */
void
ReleaseMascot(Widget w, XEvent * e, String * p, Cardinal * n)
{
    XWindowAttributes att_win;
    
    if(motion_fl){
      XtUngrabPointer(w, CurrentTime);
      XDefineCursor(XtDisplay(w), XtWindow(w), cursor_normal);
      
      XGetWindowAttributes(XtDisplay(w),XtWindow(w),&att_win);
      
      xpop=att_win.x;
      ypop=att_win.y;
    }
    else if(BalloonMode==2){
      if(balloon_decay_fl){
	XtRemoveTimeOut(balloon_decay_id);
      }
      balloon_decay_id
	=XtAppAddTimeOut(app, BALLOON_TIMEOUT*1000, DecayBalloon, NULL);
      XMapWindow(XtDisplay(w),balloon);
      balloon_decay_fl=True;
    }
    
    timing_adjust();
    update_second();


    /*if(fl_top==False){
      XLowerWindow(XtDisplay(w),XtWindow(w));
      }
      else{
      XRaiseWindow(XtDisplay(w),XtWindow(w));
	    }*/
}

void
DecayBalloon(XtPointer cl, XtIntervalId * id)
{
  XUnmapWindow(XtDisplay(mascot),balloon);
  balloon_decay_fl=False;
}

/* ץ١ ΰư */
void
MotionMascot(Widget w, XEvent * e, String * p, Cardinal * n)
{
        XEvent          ev;
        Window          root, child;
        Display        *dpy = XtDisplay(w);
        int             rx, ry, x, y;
        u_int           key;
        Dimension       mascot_w, mascot_h;
	static int drag_x, drag_y;

        if (!motion_fl) {
	    XtGrabPointer(w, False, ButtonReleaseMask | Button1MotionMask,
			  GrabModeAsync, GrabModeAsync,
			  None, cursor_tumamu, CurrentTime);
	    XQueryPointer(XtDisplay(w), XtWindow(w), &root, 
			  &child, &rx, &ry, &drag_x, &drag_y, &key);
	    if((drag_x<0)||(drag_x>=XPM_WIDTH)||
	       (drag_y<0)||(drag_y>=XPM_HEIGHT)){
		XtUngrabPointer(w, CurrentTime);
		XDefineCursor(XtDisplay(w), XtWindow(w), cursor_normal);
		return;
	    }
	    motion_fl = 1;
        }
        while (XCheckMaskEvent(dpy, Button1MotionMask, &ev));
        if (!XQueryPointer(dpy, XtWindow(w), &root, &child,
                                           &rx, &ry, &x, &y, &key))
                return;
        XtVaGetValues(w, XtNwidth, &mascot_w, XtNheight, &mascot_h, NULL);
	/*xpop=rx - mascot_w / 2;
	  ypop=ry - mascot_h / 2;*/
	xpop=rx - drag_x;
	ypop=ry - drag_y;
        XtMoveWidget(w, xpop, ypop);

	update_second();
	DoBalloon(dpy,True);
}


void sound_play()
{
    pid_t pid;
    char cmdline[1024];
    char snd_cmd[512];
    
    strcpy(snd_cmd,sound_command);
    if( (strcmp(snd_cmd,"\0")!=0) && (strcmp(sound_file,"\0")!=0) ){
	sprintf(cmdline,snd_cmd,sound_file);

	if( (pid = fork()) == 0 ){
	    system(cmdline);
	    exit(0);
	    signal(SIGCHLD,ChildTerm);
	}
    }
}

void ext_play()
{
    pid_t pid;
    char cmdline[1024];
    
    if(strcmp(ext_command,"\0")!=0){
	sprintf(cmdline,ext_command);

	if( (pid = fork()) == 0 ){
	    system(cmdline);
	    exit(0);
	    signal(SIGCHLD,ChildTerm);
	}
    }
}

/* ҥץν */
void ChildTerm(int dummy)
{
    int s;
    wait(&s);
    signal(SIGCHLD,ChildTerm);
}

void GetResource (d,w)
     /* Resource FileΥ˥塼ѥǡɤ߹ */
     Display *d;
     Widget w;
{
  XrmDatabase db;
  XrmValue val;
  FILE *fp_rc;
  char rcfile[128];
  char *type,tmp[128];
  int xpos,ypos;
  
  strcpy (rcfile, getenv("HOME"));
  strcat (rcfile, "/.akaneclockrc");


  if((fp_rc=fopen(rcfile,"r"))==NULL){
      if((fp_rc=fopen(rcfile,"w"))==NULL){
	  fprintf(stderr,"Cannot Open Config File!\n");
	  exit(1);
      }
      else{
	  fprintf(fp_rc,"Akaneclock*signal: OFF\n");
	  fprintf(fp_rc,"Akaneclock*sndFile: \n");
	  fprintf(fp_rc,"Akaneclock*sndCmd: \n");
	  fprintf(fp_rc,"Akaneclock*extCmd: \n");
      }
  }

  fclose(fp_rc);
  

  db = XrmGetFileDatabase(rcfile);


  /* position */
  if(XrmGetResource (db , "Akaneclock*X","*X",&type,&val)==True){
    strncpy(tmp,val.addr,val.size);
    xpos=atoi(tmp);
  }
  else{
    xpos=0;
  }

  if(XrmGetResource (db , "Akaneclock*Y","*Y",&type,&val)==True){
    strncpy(tmp,val.addr,val.size);
    ypos=atoi(tmp);
  }
  else{
    ypos=0;
  }

  XMoveWindow(d,XtWindow(w),xpos,ypos);

  /* ⡼ ON/OFF */
  XrmGetResource (db , "Akaneclock*signal","*signal",&type,&val);
  strncpy (tmp,val.addr,val.size);
  tmp[val.size]='\0';
  if(strcmp(tmp,"ON")==0){
      signal_fl=True;
  }
  else{
      signal_fl==False;
  }

  /* Sound ե */
  if(XrmGetResource (db , "Akaneclock*sndFile","*sndFile",&type,&val)==True){
      strncpy (sound_file,val.addr,val.size);
      sound_file[val.size]='\0';
  }
  else{
      strcpy(sound_file,"\0");
  }

  /* Soundޥ */
  if(XrmGetResource (db , "Akaneclock*sndCom","*sndCom",&type,&val)==True){
      strncpy (sound_command,val.addr,val.size);
      sound_command[val.size]='\0';
  }
  else{
      strcpy(sound_command,"\0");
  }

  /* ޥ */
  if(XrmGetResource (db , "Akaneclock*extCom","*extCom",&type,&val)==True){
      strncpy (ext_command,val.addr,val.size);
      ext_command[val.size]='\0';
  }
  else{
      strcpy(ext_command,"\0");
  }

  /* Balloon Font */
  if(XrmGetResource (db , "Akaneclock*balloonFont","*balloonFont",&type,&val)==True){
      strncpy (BalloonFont,val.addr,val.size);
      BalloonFont[val.size]='\0';
  }
  else{
      strcpy(BalloonFont,DEF_BALLOON_FONT);
  }

  /* Balloon Foreground */
  if(XrmGetResource (db , "Akaneclock*balloonFG","*balloonFG",&type,&val)==True){
      strncpy (BalloonFG,val.addr,val.size);
      BalloonFG[val.size]='\0';
  }
  else{
      strcpy(BalloonFG,DEF_BALLOON_FG);
  }

  /* Balloon Background */
  if(XrmGetResource (db , "Akaneclock*balloonBG","*balloonBG",&type,&val)==True){
      strncpy (BalloonBG,val.addr,val.size);
      BalloonBG[val.size]='\0';
  }
  else{
      strcpy(BalloonBG,DEF_BALLOON_BG);
  }

  /* Balloon Border */
  if(XrmGetResource (db , "Akaneclock*balloonBorder","*balloonBorder",&type,&val)==True){
      strncpy (BalloonBorder,val.addr,val.size);
      BalloonBorder[val.size]='\0';
  }
  else{
      strcpy(BalloonBorder,DEF_BALLOON_BORDER);
  }

  /* Balloon Position */
  if(XrmGetResource (db , "Akaneclock*balloonPosition","*balloonPosition",&type,&val)==True){
    strncpy(tmp,val.addr,val.size);
    BalloonPosition=atoi(tmp);
  }
  else{
    BalloonPosition=DEF_BALLOON_POSITION;
  }

  /* Balloon Offset X */
  if(XrmGetResource (db , "Akaneclock*balloonOffX","*balloonOffX",&type,&val)==True){
    strncpy(tmp,val.addr,val.size);
    BalloonOffX=atoi(tmp);
  }
  else{
    BalloonOffX=DEF_BALLOON_OFFX;
  }

  /* Balloon Offset Y */
  if(XrmGetResource (db , "Akaneclock*balloonOffY","*balloonOffY",&type,&val)==True){
    strncpy(tmp,val.addr,val.size);
    BalloonOffY=atoi(tmp);
  }
  else{
    BalloonOffY=DEF_BALLOON_OFFY;
  }

  /* Balloon Mode */
  if(XrmGetResource (db , "Akaneclock*balloonMode","*balloonMode",&type,&val)==True){
    strncpy(tmp,val.addr,val.size);
    BalloonMode=atoi(tmp);
  }
  else{
    BalloonMode=DEF_BALLOON_MODE;
  }
}


/* Resource FileؤΥ˥塼ѥǡ񤭹 */
void SaveResource (w)
     Widget w;
{
  FILE *fp_rc;
  char rcfile[128];
  XWindowAttributes att_win;

  strcpy (rcfile, getenv("HOME"));
  strcat (rcfile, "/.akaneclockrc");

  if((fp_rc=fopen(rcfile,"w"))==NULL){
      fprintf(stderr,"Cannot Open Config File!\n");
      fclose(fp_rc);
      exit(1);
  }
  

  if(signal_fl==True){
      fprintf(fp_rc,"Akaneclock*signal: %s\n","ON");
  }
  else{
      fprintf(fp_rc,"Akaneclock*signal: %s\n","OFF");
  }

  XGetWindowAttributes(XtDisplay(w),XtWindow(w),&att_win);
  
  fprintf(fp_rc,"Akaneclock*X: %d\n",att_win.x);
  fprintf(fp_rc,"Akaneclock*Y: %d\n",att_win.y);
  fprintf(fp_rc,"Akaneclock*sndFile: %s\n",sound_file);
  fprintf(fp_rc,"Akaneclock*sndCom: %s\n",sound_command);
  fprintf(fp_rc,"Akaneclock*extCom: %s\n\n",ext_command);
  fprintf(fp_rc,"Akaneclock*balloonFont: %s\n",BalloonFont);
  fprintf(fp_rc,"Akaneclock*balloonFG: %s\n",BalloonFG);
  fprintf(fp_rc,"Akaneclock*balloonBG: %s\n",BalloonBG);
  fprintf(fp_rc,"Akaneclock*balloonBorder: %s\n",BalloonBorder);
  fprintf(fp_rc,"Akaneclock*balloonPosition: %d\n",BalloonPosition);
  fprintf(fp_rc,"Akaneclock*balloonOffX: %d\n",BalloonOffX);
  fprintf(fp_rc,"Akaneclock*balloonOffY: %d\n",BalloonOffY);
  fprintf(fp_rc,"Akaneclock*balloonMode: %d\n",BalloonMode);

  fclose(fp_rc);
}


void
SetChangeHand()
{
    time_t t;
    struct tm *tmpt;
    static long priset;

    t = time(NULL);
    tmpt = localtime(&t);

    priset=3600 - (tmpt->tm_min)*60 - (tmpt->tm_sec);
    /*priset=60 - (tmpt->tm_sec);*/   /* For DEBUG */
    signal_id=XtAppAddTimeOut(app, priset * 1000, ChangeHand, NULL);
}

/* ¹ */
void
ChangeHand(XtPointer cl, XtIntervalId * id)
{
    sound_play();
    ext_play();

    SetChangeHand();
}

/* Config WindowλToggle */
static void SigCheck(w,client_data,call_data)
     Widget w;
     caddr_t client_data;
     caddr_t call_data;
{
    Boolean sw;

    XtVaGetValues(w,XtNstate,&sw,NULL);

    if(sw==True){
	XtVaSetValues(conf_sig_wav,XtNsensitive,True,NULL);
	XtVaSetValues(conf_sig_wavcmd,XtNsensitive,True,NULL);
	XtVaSetValues(conf_sig_cmd,XtNsensitive,True,NULL);
    }
    else{
	XtVaSetValues(conf_sig_wav,XtNsensitive,False,NULL);
	XtVaSetValues(conf_sig_wavcmd,XtNsensitive,False,NULL);
	XtVaSetValues(conf_sig_cmd,XtNsensitive,False,NULL);
    }
}

void InitBalloon(Display *d)
{
    XSetWindowAttributes att_balloon;
    XGCValues	gcv;

    int		FontHeight;
    int i;

    
    fg_balloon = GetColor(d, BalloonFG,RootWindow(d,0));
    bg_balloon = GetColor(d, BalloonBG,RootWindow(d,0));
    border_balloon = GetColor(d, BalloonBorder,RootWindow(d,0));

    /* դɽWindow */
    balloon = XCreateSimpleWindow( d, RootWindow(d,0),
				     100, 100, 120, 64, 1,
				  fg_balloon,
				  bg_balloon);
    att_balloon.override_redirect = True;
    att_balloon.backing_store = WhenMapped;
    if(useSaveUnder){
	att_balloon.save_under = True;
	XChangeWindowAttributes( d, balloon, CWSaveUnder|CWOverrideRedirect, &att_balloon );
    }
    else
	XChangeWindowAttributes( d, balloon, CWOverrideRedirect, &att_balloon );
    theFont = XLoadQueryFont( d, BalloonFont );
    /*theFont = XLoadQueryFont( d, "-*-fixed-medium-r-normal--14-*" );
      theFont = XLoadQueryFont( d, "-*-*-*-*-*--14-*" );*/
    if( theFont == NULL ) {/* եȤĤʤ */
	fprintf(stderr," Cannot Load Font \"%s\".\n", BalloonFont);
	exit(1);
    }
    FontHeight = theFont->max_bounds.ascent + theFont->max_bounds.descent;

    gcv.font = theFont->fid;
    gcv.foreground = fg_balloon;
    gcv.background = bg_balloon;
    gc_balloon = XCreateGC( d, RootWindow(d,0),
			      GCForeground | GCBackground | GCFont, &gcv );
}

void DoBalloon(d, fl_move)
     Display *d; 
     Boolean fl_move;
{
  static int dir, ascent, descent;
  /*XChar2b kstr[128];*/
  static char kstr[128];
  static char wp[128];
  static XCharStruct cs;
  int width, height, x0, y0, x1, y1;
  int pos=BalloonPosition;
  static char word_tmp[512];
  Pixmap pixmap;
  static char initial_week[20][20]={"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"};
  static char initial_mon[20][20]={"Jan", "Feb", "Mar", "Apr", "May", "Jun",
			   "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};
  
  Window rootwin;
  int win_x,win_y;
  unsigned int win_width,win_height,border,depth;
  
  time_t t;
  struct tm *tmpt;

  t = time(NULL);
  tmpt = localtime(&t);

  if((tmpt->tm_min!=pre_min)||(fl_move==True)){
    pre_min=tmpt->tm_min;
  }
  else{
    if(abs(pos)==2){
      XDrawString( d, balloon, gc_balloon,
		   5, cs.ascent+5+8, kstr, strlen(wp));
    }
    else{
      XDrawString( d, balloon, gc_balloon,
		   5, cs.ascent+5, kstr, strlen(wp));
    }
      
    return;
  }

  sprintf(wp,"%s %s %02d  %02d:%02d  %04d",initial_week[tmpt->tm_wday],
	  initial_mon[tmpt->tm_mon], tmpt->tm_mday, tmpt->tm_hour,
	  tmpt->tm_min, tmpt->tm_year+1900);
  /*Str2bCpy( kstr, wp);*/
  strcpy( kstr, wp);
  
  XTextExtents(theFont, kstr, strlen(wp),
		 &dir, &ascent, &descent, &cs);
  width = cs.rbearing + cs.lbearing + 10;
  height = cs.ascent + cs.descent + 10;
  
  pos = SetBalloonPos(mascot,balloon,width,height);
  

  XGetGeometry(d,balloon,&rootwin,&win_x,&win_y,&win_width,&win_height,
      &border,&depth);
  pixmap = XCreatePixmap(d, RootWindow(d,0),width,height+8,depth);


  if(BalloonBorderWidth > 0) {
    XSetForeground(d,gc_balloon,border_balloon);
    XFillRectangle(d,pixmap,gc_balloon,0,0,width,height+8);
    XSetForeground(d,gc_balloon,bg_balloon);
    drawBalloon(d,pixmap,gc_balloon,BalloonBorderWidth,BalloonBorderWidth,
		width-2*BalloonBorderWidth,height-2*BalloonBorderWidth,pos);
  } else {
    XSetForeground(d,gc_balloon,bg_balloon);
    XFillRectangle(d,pixmap,gc_balloon,0,0,width,height+8);
  }
  XSetWindowBackgroundPixmap(d,balloon,pixmap);

  ShapeBalloon(d,width,height,pos);

  if(BalloonMode==1){
    XMapWindow(d, balloon);
    XRaiseWindow(d, balloon);
  }
  
  XSetForeground(d,gc_balloon,fg_balloon);
  if(abs(pos)==2){
    XDrawString( d, balloon, gc_balloon,
		 5, cs.ascent+5+8, kstr, strlen(wp));
  }
  else{
    XDrawString( d, balloon, gc_balloon,
		 5, cs.ascent+5, kstr, strlen(wp));
  }
  XFreePixmap(d,pixmap);

}

int SetBalloonPos(Widget w, Window ww, int width, int height)
{
  /* w=mascot, ww=balloon */
    XWindowAttributes att_win,att_root;
    int xpopup,ypopup;
    int win_pos=BalloonPosition;
    int mascot_w,mascot_h;

    XResizeWindow(XtDisplay(w),ww,width,height);
    
    XGetWindowAttributes(XtDisplay(w),XtWindow(w),&att_win);
    XGetWindowAttributes(XtDisplay(w),RootWindow(XtDisplay(w),0),&att_root);

    if(BalloonPosition==1){ /* default  */
      xpopup=att_win.x+att_win.width-BalloonOffX; 
      ypopup=att_win.y+BalloonOffY;
    }
    else if(BalloonPosition==-2){ /*  */
      xpopup=att_win.x-width+BalloonOffX;
      ypopup=att_win.y+att_win.height-height-8-BalloonOffY;
    }
    else if(BalloonPosition==2){ /*  */
      xpopup=att_win.x+att_win.width-BalloonOffX; 
      ypopup=att_win.y+att_win.height-height-8-BalloonOffY;
    }
    else{ /*  */
      xpopup=att_win.x-width+BalloonOffX;
      ypopup=att_win.y+BalloonOffY;
    }

    if(xpopup<0){ /* Window κü */
      xpopup=att_win.x+att_win.width-BalloonOffX; 
      win_pos=abs(win_pos);
    }

    if(xpopup>att_root.width-width){
      xpopup=att_win.x-width+BalloonOffX; /* Window αü */
      win_pos=-abs(win_pos);
    }
      

    if(ypopup<0){
	ypopup=0;
    }
    else if(ypopup+height>att_root.height){
      if(abs(BalloonPosition)==2){
	ypopup=att_root.height-height-8-BalloonOffY;
      }
      else{
	ypopup=att_root.height-height+-BalloonOffY;
      }
    }

    XMoveWindow(XtDisplay(w),ww,xpopup,ypopup);

    return win_pos;
}

/*
 ᤭Ф (loosely based WindowMaker 0.61.1)
*/
void drawBalloon(d, p, gc, x, y, w, h, pos)
     Display *d;
     Pixmap p;
     GC gc;
     int x,y,w,h,pos;
{
  static int edge = 8;
  int rad = h*3/10;
  XPoint pt[3];
  
  if(abs(pos)==1){
    XFillArc(d, p, gc, x, y, rad, rad, 90*64, 90*64);
    XFillArc(d, p, gc, x, y+h-1-rad, rad, rad, 180*64, 90*64);
    
    XFillArc(d, p, gc, x+w-1-rad, y, rad, rad, 0*64, 90*64);
    XFillArc(d, p, gc, x+w-1-rad, y+h-1-rad, rad, rad, 270*64, 90*64);
  
    XFillRectangle(d, p, gc, x, y+rad/2, w, h-rad);
    XFillRectangle(d, p, gc, x+rad/2, y, w-rad, h);
  }
  else{
    XFillArc(d, p, gc, x, y+8, rad, rad, 90*64, 90*64);
    XFillArc(d, p, gc, x, y+8+h-1-rad, rad, rad, 180*64, 90*64);
    
    XFillArc(d, p, gc, x+w-1-rad, y+8, rad, rad, 0*64, 90*64);
    XFillArc(d, p, gc, x+w-1-rad, y+8+h-1-rad, rad, rad, 270*64, 90*64);
  
    XFillRectangle(d, p, gc, x, y+8+rad/2, w, h-rad);
    XFillRectangle(d, p, gc, x+rad/2, y+8, w-rad, h);
  }
  
  if( pos<0 ){  /*  */
    pt[0].x = x+w-h+2*h/16;
    pt[1].x = x+w-h+11*h/16;
    pt[2].x = x+w-h+7*h/16;
  } else { /*  */
    pt[0].x = x+h-2*h/16;
    pt[1].x = x+h-11*h/16;
    pt[2].x = x+h-7*h/16;
  }


  if(abs(pos)==1){  /*  */
    pt[0].y = y+h-1;
    pt[1].y = y+h-1+8; /* WindowMaker Ǥ 12 */
    pt[2].y = y+h-1;
  }
  else{ /*  */
    pt[0].y = y+1+8;
    pt[1].y = y+1; /* WindowMaker Ǥ 12 */
    pt[2].y = y+1+8;
  }
  
  XFillPolygon(d, p, gc, pt, 3, Convex, CoordModeOrigin);
    
}

/*
 ɥ֤դפηڤФ
*/
void ShapeBalloon(d, width, height, pos_flag)
     Display *d;
     int	width, height, pos_flag;
{
    GC		gc_mask;
    Pixmap	bitmap;
    
    /* ޥѥӥåȥޥåפ */
    bitmap = XCreatePixmap( d, balloon, width, height+8, 1/*depth=1*/ );
    gc_mask = XCreateGC( d, bitmap, 0, NULL );
    
    /* ޤ̥ꥢ */
    /* XSetForeground( d, gc_mask, BlackPixel(d,DefaultScreen(d)) );*/
    XSetForeground( d, gc_mask, 0);
    XFillRectangle( d, bitmap, gc_mask, 0, 0, width, height+8 );

    
    /* Balloon  */
    /* XSetForeground( d, gc_mask, WhitePixel(d,DefaultScreen(d)) ); */
    XSetForeground( d, gc_mask, 1);
    drawBalloon(d, bitmap, gc_mask, 0, 0, width, height, pos_flag);

    /* resize ڤФ */
    XResizeWindow( d, balloon, width, height+8 );
    XShapeCombineMask( d, balloon, ShapeBounding, 0, 0, bitmap, ShapeSet );
    
    XFreeGC( d, gc_mask );
    XFreePixmap( d, bitmap );
}

/* б Pixel  (Х롼οǻ)*/
Pixel GetColor(Display *d, char *name,Window w)
{
  XWindowAttributes attr;
  XColor color;
  XGetWindowAttributes(d, w, &attr);
  if (!XParseColor(d, attr.colormap, name, &color))
  {
    fprintf(stderr, "GetColor : cannot parse color \"%s\".\n",name);
    exit(1);
  }
  else if (!XAllocColor(d, attr.colormap, &color)) {
    fprintf(stderr, "GetColor : can't allocate \"%s\".\n", name);
  }
  return color.pixel;
}

/******** Str2bCpy ********
* ʸcharXChar2b ˥ԡ from xosmult ver1.0
*/
XChar2b	*Str2bCpy( dst, src )
	XChar2b	*dst;
	char	*src;
{
	int	i;

	for( i=0; i < strlen( src ) / 2; i++ )
	{
	    dst[i].byte1 = src[ i*2     ] & 0x7f;
	    dst[i].byte2 = src[ i*2 + 1 ] & 0x7f;
	}
	dst[i].byte1 = 
	dst[i].byte2 = '\0';

	return( dst );
}
